var isIE = false;
var service_url = "http://lsdis.cs.uga.edu/items/proxy.php";
var menu_div;
var timeout;


var topicQuery = " PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>" +
" PREFIX dc: <http://purl.org/dc/elements/1.1/>" +
" PREFIX swt: <http://lsdis.cs.uga.edu/library/resources/ontologies/swtopics.owl#>" +
" SELECT ?type ?desc ?alt ?related ?rel_label" +
" WHERE " +
"  {" +
"    { #placeholder# rdfs:type ?type }" +
"    UNION" +
"    { #placeholder# dc:description ?desc }" +
"    UNION" +
"    { #placeholder# dc:alternative ?alt }" +
"    UNION" +
"    { #placeholder# swt:topic_relatedTo ?related. ?related rdfs:label ?rel_label }" +
" }";


var personQuery = " PREFIX opus: <http://lsdis.cs.uga.edu/projects/semdis/opus#>" + 
" PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>" +
" PREFIX foaf: <http://xmlns.com/foaf/0.1/>" + 
" PREFIX talk: <http://daml.umbc.edu/ontologies/talk-ont#>"+
" SELECT ?homepage ?affiliation ?aLabel ?expertise " +
" WHERE" +
" {" +
"   { #placeholder# foaf:homepage ?homepage }" +
"     UNION" +
"   { #placeholder# opus:affiliation ?affiliation." +
"   ?affiliation rdfs:label ?aLabel }" +
"     UNION" +
"   { #placeholder# talk:expertise ?expertise }" +
" }";


var orgQuery = " PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>" +
" PREFIX dc: <http://purl.org/dc/elements/1.1/>" +
" SELECT ?desc ?label " +
" WHERE" +
" {" +
"   #placeholder# dc:description ?desc. " +
"   #placeholder# rdfs:label ?label. " +
" }";


function initAnnotation(elmt){
	if(window.ActiveXObject) isIE = true;
	
	if(!elmt) elmt = document.body;
	else elmt = document.getElementById(elmt);
	
	
	
	/*var debug = document.createElement("textarea");
	debug.rows = "20";
	debug.cols = "100";
	debug.id = "debug";
	document.body.appendChild(debug);*/
	
	
	//var textNodes = getTextNodes(elmt);
	
	//output = replaceMatches(getMatches(elmt.innerHTML, new RegExp("<.+?>", "g")), elmt.innerHTML);
	
	//var text = "";
	
	//for(var i=0; i<textNodes.length; i++){
	//	text += textNodes[i].data + " ";
	//}
	//alert(text);
	
	var str = elmt.innerHTML;//trim(elmt.innerHTML);
	if(str.indexOf("<pre>") == -1 && str.indexOf("<PRE>") == -1) str = str.replace(/\n/g, " ").replace(/ +/g, " ");
	
	//debug.value = str;
	
	//var startTime = new Date().getTime();
	
	var detag = replaceMatches(getMatches(str, new RegExp("<a.*?>.*?</a>", "g")), str);
	detag = replaceMatches(getMatches(detag, new RegExp("<.+?>", "g")), detag);
		
	var xmlDoc = /*loadXML_noAsync("url=" + document.location); /*/loadXML_noAsync("q="+escape(detag)+"&url="+document.location+"&title="+escape(document.title));
	
	//var stopTime = new Date().getTime();
	
	//alert(stopTime - startTime);
	
	
	//startTime = new Date().getTime();
	
	var entity = xmlDoc.getElementsByTagName("entity");
	
	
	for(var i=entity.length-1; i>-1; i--){
	
		var name = entity[i].getElementsByTagName("entityName")[0];
		var positions = entity[i].getElementsByTagName("position");
		var uri = entity[i].getElementsByTagName("uri")[0].firstChild.data;
		var type = entity[i].getElementsByTagName("classname")[0].firstChild.data;
		for(var j=0; j<positions.length; j++){
			var start = parseInt(positions[j].getElementsByTagName("start")[0].firstChild.data);
			var end = parseInt(positions[j].getElementsByTagName("end")[0].firstChild.data);
			//for(var k=0; k<textNodes.length; k++){
				//str = str.replace(names[j].firstChild.data, "<span class=\"annotated\" onclick=\"showLink('"+uri+"');\">"+names[j].firstChild.data+"</span>"); //
			//}
			//alert(start + " :: " + end);
			
			//start = parseInt(start) + ((str.substring(0, start).match(/[<>"\(\),=:/]/g)).length * 3);
			//alert(start);
			
			var replacement = "<span class=\"annotated\" onclick=\"showMetadata('"+uri+"', '"+type+"'); hideMetadata(5000);\">"+str.substring(start, end)+"</span>";
			
			//str = spliceString(str, replacement, start+10, end+10);
			str = spliceString(str, replacement, start, end);
		}
	}
	
	//stopTime = new Date().getTime();
	
	//alert(stopTime - startTime);
	
	//debug.value = elmt.innerHTML;
	
	elmt.innerHTML = str;
		
	menu_div = document.createElement("div");
	menu_div.className = "menu_div";
	menu_div.style.display = "none";
	document.body.appendChild(menu_div);
			
}

function getTextNodes(elmt){
	if(elmt.nodeName == "#text") return new Array(elmt);
	var child = elmt.childNodes;
	var result = new Array();
	for(var i=0; i<child.length; i++){
		result = result.concat(getTextNodes(child[i]));
	}
	return result;
}

function showMetadata(uri, type){
	if(timeout) clearTimeout(timeout);
	
	if(type == "http://xmlns.com/foaf/0.1/Person"){
		showPersonMetadata(uri);
	}else if(type == "http://xmlns.com/foaf/0.1/Organization" ||
			type == "http://lsdis.cs.uga.edu/projects/semdis/opus#University"){
		showOrgMetadata(uri);
	}else{
		showTopicMetadata(uri);
	}	
}


function showTopicMetadata(uri){
	var xmlDoc = null;
	var header = null;

	menu_div.innerHTML = "";
	
	xmlDoc = loadXML_noAsync("tsparql=" + topicQuery.replace(/#placeholder#/g, "<"+uri+">").replace(/#/g, "%23"));
	
	var info_div = document.createElement("div");
	var wp_div = document.createElement("div");
	
	/********************************************
	 * Synonyms
	 */
	var list = document.createElement("ul");
	list.className = "annotation";
	var binding = xmlDoc.getElementsByTagName("binding");
	//alert(binding.length);
	for(var i=0; i<binding.length; i++){
		if(binding[i].getAttribute("name") == "alt"){
			if(binding[i].getElementsByTagName("literal")[0].firstChild){
				var val = binding[i].getElementsByTagName("literal")[0].firstChild.data;
				var li = document.createElement("li");
				li.innerHTML = ""+val+"";
				list.appendChild(li);
			}
		}
	}
	
	if(list.childNodes.length > 0){
		header = document.createElement("p");
		header.className = "header";
		header.style.margin = "0px";
		header.innerHTML = "Synonyms";
		info_div.appendChild(header);
		info_div.appendChild(list);
	}
	
	/********************************************
	 * Description
	 */
	
	list = document.createElement("ul");
	list.className = "annotation";
	
	for(var i=0; i<binding.length; i++){
		if(binding[i].getAttribute("name") == "desc"){
			var val = binding[i].getElementsByTagName("literal")[0].firstChild.data;
			var li = document.createElement("li");
			li.innerHTML = ""+val+"";
			list.appendChild(li);
			break;
		}
	}
	
	if(list.childNodes.length < 1){
		var li = document.createElement("li");
		li.innerHTML = "-";
		list.appendChild(li);
	}
	
	header = document.createElement("p");
	header.className = "header";
	header.style.margin = "0px";
	header.innerHTML = "Description";
	info_div.appendChild(header);
	info_div.appendChild(list);
	
	/********************************************
	 * Related Topics
	 */
	
	list = document.createElement("ul");
	list.className = "annotation";
	
	for(var i=0; i<binding.length; i++){
		if(binding[i].getAttribute("name") == "rel_label"){
			if(binding[i].getElementsByTagName("literal")[0].firstChild){
				var val = binding[i].getElementsByTagName("literal")[0].firstChild.data;
				var li = document.createElement("li");
				li.innerHTML = ""+val+"";
				list.appendChild(li);
			}
		}
	}
	if(list.childNodes.length > 0){
		header = document.createElement("p");
		header.className = "header";
		header.style.margin = "0px";
		header.innerHTML = "Related Topics";
		info_div.appendChild(header);
		info_div.appendChild(list);
	}
		
	/********************************************
	 * Featured webpages
	 */
	wp_div.innerHTML = loadXML_noAsync("twp=" + uri.replace("#", "%23"), true);
	
	buildAnnotation(info_div, wp_div);
}


function showPersonMetadata(uri){
	var xmlDoc = null;
	var header = null;

	var info_div = document.createElement("div");
	var wp_div = document.createElement("div");
	
	xmlDoc = loadXML_noAsync("psparql=" + personQuery.replace(/#placeholder#/g, "<"+uri+">").replace(/#/g, "%23"));
	
	/********************************************
	 * DBLP Entry
	 */
	var list = document.createElement("ul");
	list.className = "annotation";
	list.style.listStyle = "none inside none";
	list.style.margin = "0px";
	
	var li = document.createElement("li");
	li.innerHTML = "<a href='"+uri+"' target='_blank'>Go to DBLP</a> (Opens in a new window)";
	list.appendChild(li);
	
	if(list.childNodes.length > 0){
		header = document.createElement("p");
		header.className = "header";
		header.style.margin = "0px";
		header.innerHTML = "DBLP Entry";
		info_div.appendChild(header);
		info_div.appendChild(list);
	}
	
	
	/********************************************
	 * Homepage
	 */
	var list = document.createElement("ul");
	list.className = "annotation";
	list.style.listStyle = "none inside none";
	list.style.margin = "0px";
	
	var url = "";
	var label = "";
	var exper = new Array();
	
	var binding = xmlDoc.getElementsByTagName("binding");
	//alert(binding.length);
	for(var i=0; i<binding.length; i++){
		if(binding[i].getAttribute("name") == "homepage"){
			var val = binding[i].getElementsByTagName("uri")[0].firstChild.data;
			var li = document.createElement("li");
			
			var openTag = "<a href='"+val+"'>";
			
			if(val.length > 40) val = val.substring(0, 39) + "...";
			
			li.innerHTML = openTag+""+val+"</a>";
			list.appendChild(li);
		}else if(binding[i].getAttribute("name") == "affiliation"){
			url = binding[i].getElementsByTagName("uri")[0].firstChild.data;
		}else  if(binding[i].getAttribute("name") == "aLabel"){
			label = binding[i].getElementsByTagName("literal")[0].firstChild.data;
		}else  if(binding[i].getAttribute("name") == "expertise"){
			exper[exper.length] = binding[i].getElementsByTagName("literal")[0].firstChild.data;
		}
	}
	
	
	if(list.childNodes.length > 0){
		header = document.createElement("p");
		header.className = "header";
		header.style.margin = "0px";
		header.innerHTML = "Homepage";
		info_div.appendChild(header);
		info_div.appendChild(list);
	}
	
	/********************************************
	 * Affiliation
	 */
	if(url != ""){
		if(label == "") label = url;
		var list = document.createElement("ul");
		list.className = "annotation";
		list.style.listStyle = "none inside none";
		list.style.margin = "0px";
	
		var li = document.createElement("li");
		li.innerHTML = "<a href='"+url+"'>"+label+"</a>";
		list.appendChild(li);
		
		header = document.createElement("p");
		header.className = "header";
		header.style.margin = "0px";
		header.innerHTML = "Affiliation";
		info_div.appendChild(header);
		info_div.appendChild(list);
	}
	
	if(info_div.innerHTML == ''){
		header = document.createElement("p");
		header.className = "header";
		header.style.margin = "0px";
		header.innerHTML = "No Additional Information";
		info_div.appendChild(header);
	}
	
	/********************************************
	 * Expertise
	 */
	if(exper.length != 0){
		var list = document.createElement("ul");
		list.className = "annotation";
		list.style.listStyle = "none inside none";
		list.style.margin = "0px";
	
		for(var i=0; i<exper.length; i++){
			var li = document.createElement("li");
			li.innerHTML = exper[i];
			list.appendChild(li);
		}
		
		header = document.createElement("p");
		header.className = "header";
		header.style.margin = "0px";
		header.innerHTML = "Areas of Expertise Include";
		info_div.appendChild(header);
		info_div.appendChild(list);
	}
	
	if(info_div.innerHTML == ''){
		header = document.createElement("p");
		header.className = "header";
		header.style.margin = "0px";
		header.innerHTML = "No Additional Information";
		info_div.appendChild(header);
	}
	
	/********************************************
	 * Featured webpages
	 */
	wp_div.innerHTML = loadXML_noAsync("pwp=" + uri.replace("#", "%23"), true);
	
	buildAnnotation(info_div, wp_div);
}

function showOrgMetadata(uri){
	var xmlDoc = null;
	var header = null;

	var info_div = document.createElement("div");
	var wp_div = document.createElement("div");
	
	xmlDoc = loadXML_noAsync("psparql=" + orgQuery.replace(/#placeholder#/g, "<"+uri+">").replace(/#/g, "%23"));
	
	
	/********************************************
	 * Description
	 */
	var list = document.createElement("ul");
	list.className = "annotation";
	list.style.listStyle = "none inside none";
	list.style.margin = "0px";
	
	var url = "";
	var label = "";
	
	var binding = xmlDoc.getElementsByTagName("binding");
	//alert(binding.length);
	for(var i=0; i<binding.length; i++){
		if(binding[i].getAttribute("name") == "desc"){
			var val = binding[i].getElementsByTagName("literal")[0].firstChild.data;
			var li = document.createElement("li");
			li.innerHTML = val;
			list.appendChild(li);
		}else  if(binding[i].getAttribute("name") == "label"){
			label = binding[i].getElementsByTagName("literal")[0].firstChild.data;
		}
	}
	
	if(list.childNodes.length > 0){
		header = document.createElement("p");
		header.className = "header";
		header.style.margin = "0px";
		header.innerHTML = "Description";
		info_div.appendChild(header);
		info_div.appendChild(list);
	}
	
	/********************************************
	 * Label
	 */
	if(label != ""){
		if(label == "") label = url;
		var list = document.createElement("ul");
		list.className = "annotation";
		list.style.listStyle = "none inside none";
		list.style.margin = "0px";
	
		var li = document.createElement("li");
		li.innerHTML = "<a href='"+uri+"'>"+label+"</a>";
		list.appendChild(li);
		
		header = document.createElement("p");
		header.className = "header";
		header.style.margin = "0px";
		header.innerHTML = "Website";
		info_div.appendChild(header);
		info_div.appendChild(list);
	}
	
	if(info_div.innerHTML == ''){
		var list = document.createElement("ul");
		list.className = "annotation";
		list.style.listStyle = "none inside none";
		list.style.margin = "0px";
	
		var li = document.createElement("li");
		li.innerHTML = "<a href='"+uri+"'>"+uri+"</a>";
		list.appendChild(li);
		
		header = document.createElement("p");
		header.className = "header";
		header.style.margin = "0px";
		header.innerHTML = "Website";
		info_div.appendChild(header);
		info_div.appendChild(list);
	}
	
	/********************************************
	 * Featured webpages
	 */
	wp_div.innerHTML = loadXML_noAsync("pwp=" + uri.replace("#", "%23"), true);
	
	buildAnnotation(info_div, wp_div);
}

function buildAnnotation(info_div, wp_div){

	menu_div.innerHTML = "";
	
	var top = document.createElement("div");
	top.style.background = "url(/images/box_top2.gif) no-repeat";
	top.style.width = "100%";
	top.style.height = "14px";
	menu_div.appendChild(top);	
	
	var table = document.createElement("table");
	table.style.width = "100%";
	table.style.backgroundColor = "#fff";
	table.cellpadding = "0";
	table.cellspacing = "0";
	table.style.borderLeft = "1px solid #666";
	table.style.borderRight = "1px solid #666";
	table.appendChild(document.createElement("tbody"));
	var tr = document.createElement("tr");
	var td = document.createElement("td");
	tr.appendChild(td);

	table.firstChild.appendChild(tr);
	
	tr = document.createElement("tr");
	td = document.createElement("td");
		
	td.innerHTML = "Information";
	td.id = "info_tab";
	td.onclick = new Function("openTab('info');");
	td.className = "tab_lite";
	tr.appendChild(td);
	
	td = document.createElement("td");
	td.className = "tab";
	
	if(wp_div.innerHTML.replace(/[\n ]/g, "") == ""){
		td.innerHTML = "Only Found Here";
	}else{
		td.innerHTML = "Also Featured In";
		td.onclick = new Function("openTab('related');");
	}
	td.id = "related_tab";
	tr.appendChild(td);
	
	td = document.createElement("td");
	tr.appendChild(td);
	table.firstChild.appendChild(tr);
	
	tr = document.createElement("tr");
	tr.appendChild(document.createElement("td"));
	tr.firstChild.colSpan = "3";
	tr.firstChild.appendChild(info_div);
	tr.id = "info";
	table.firstChild.appendChild(tr);
	
	tr = document.createElement("tr");
	tr.appendChild(document.createElement("td"));
	tr.firstChild.colSpan = "3";
	tr.firstChild.appendChild(wp_div);
	tr.style.display = "none";
	tr.id = "related";
	table.firstChild.appendChild(tr);
	
	menu_div.appendChild(table);
	
	var bottom = document.createElement("div");
	bottom.style.background = "url(/images/box_bottom2.gif) no-repeat";
	bottom.style.width = "100%";
	bottom.style.height = "20px";
	menu_div.appendChild(bottom);	
	
	menu_div.onmouseover = new Function("if(timeout) clearTimeout(timeout);");
	menu_div.onmouseout = new Function("hideMetadata();");
	menu_div.style.display = "";
	menu_div.style.top = mY + "px";
	menu_div.style.left = mX + "px";
}

function hideMetadata(duration){
	if(!duration) duration = 1500;
	timeout = setTimeout("menu_div.style.display = \"none\";", duration);
}

function openTab(type){
	if(type == "info"){
		document.getElementById("info").style.display = "";
		document.getElementById("info_tab").className = "tab_lite";
		document.getElementById("related").style.display = "none";
		document.getElementById("related_tab").className = "tab";
	}else{
		document.getElementById("info").style.display = "none";
		document.getElementById("info_tab").className = "tab";
		document.getElementById("related").style.display = "";
		document.getElementById("related_tab").className = "tab_lite";
	}
}

function loadXML_noAsync(params, text){
   	
   	var url = service_url;
   	
   	//alert(url + "?" + params);
   	//var url = "annotate.xml";
   	//document.getElementById("debug").value = params;
   	   	
   	// branch for native XMLHttpRequest object
	if(!isIE){
		req = new XMLHttpRequest();
		//req.onreadystatechange = function () { processReqChange(type, aux1, aux2, aux3)};
		req.open("POST", url, false);
		req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		req.send(params);
	// branch for IE/Windows ActiveX version
	}else if(isIE){
		isIE = true;
		req = new ActiveXObject("Microsoft.XMLHTTP");
		if(req){
			//req.onreadystatechange = function () { processReqChange(type, aux1, aux2, aux3);};
			req.open("POST", url, false);
			req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			req.send(params);
		}
	}
	
	//document.getElementById("debug").value += "\n\n************************\n\n" + req.responseText;
	//alert(req.responseText);	
	if(text) return req.responseText;
	//if(text) return req.responseText;
	return req.responseXML;
}

function spliceString(original, insertion, start, end){
	return original.substring(0, start) + insertion + original.substring(end, original.length);
}

function getMatches(input, regex){
	return input.match(regex);
}

function replaceMatches(matches, output){
	var replacement;
	
	if(matches){
		for(var i=0; i<matches.length; i++){
			replacement = "";
			for(var j=0; j<matches[i].length; j++){
				replacement += ' ';
			}
			output = output.replace(matches[i], replacement);
		}
	}
	return output;
}

function trim(string){

	var start = 0;
	var nl = string.indexOf("\n");
	var sp = string.indexOf(" ");
	while(nl == start || sp == start){
		start++;
		nl = string.indexOf("\n", start);
		sp = string.indexOf(" ", start);
	}
	
	var end = string.length;
	nl = string.lastIndexOf("\n");
	sp = string.lastIndexOf(" ");
	while(nl == end || sp == end){
		end--;
		nl = string.indexOf("\n", end);
		sp = string.indexOf(" ", end);
	}
	
	//alert(start + "  " + end);
	
	return string.substring(start, end);
	
}



/**********************************
 **********************************
	      EVENTS HERE
 **********************************
 **********************************/

if (isIE) document.captureEvents(Event.MOUSEMOVE)
document.onmousemove = getMouseXY;
var mX = 0;
var mY = 0;
function getMouseXY(e) {
	if (isIE) { // grab the x-y pos.s if browser is IE
		mX = event.clientX + document.body.scrollLeft;
		mY = event.clientY + document.body.scrollTop;
	}else{  // grab the x-y pos.s if browser is NS
		mX = e.pageX;
		mY = e.pageY;
	}
	if (mX < 0){mX = 0;}
	if (mY < 0){mY = 0;}
	return true;
}


